-- GLOBALS: unpack, select, LibStub, ITEM_SEARCHBAR_LIST
-- GLOBALS: VoidStorageFrame, ReagentBankFrame, MerchantFrame

--[[//////////////////////////////////////////////////

    GLO-LO

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]

    local _G = _G
    local math = math
    local tostring = tostring
    local tonumber = tonumber
    local string = string
    local pairs = pairs
    local format = format
    local tinsert = tinsert
    local strmatch = strmatch
    local strsplit = strsplit

    local CreateFrame = CreateFrame
    local UIParent = UIParent
    local ResetCursor = ResetCursor
    local SetCursor = SetCursor
    local ShowInspectCursor = ShowInspectCursor
    local GameTooltip = GameTooltip
    local GameTooltip_Hide = GameTooltip_Hide
    local GameTooltip_ShowCompareItem = GameTooltip_ShowCompareItem
    local BattlePetToolTip_Show = BattlePetToolTip_Show
    local BattlePetTooltip = BattlePetTooltip
    local CloseDropDownMenus = CloseDropDownMenus
    local ToggleDropDownMenu = ToggleDropDownMenu
    local UIDropDownMenu_CreateInfo = UIDropDownMenu_CreateInfo
    local UIDropDownMenu_SetWidth = UIDropDownMenu_SetWidth
    local UIDropDownMenu_Initialize = UIDropDownMenu_Initialize
    local UIDropDownMenu_AddButton = UIDropDownMenu_AddButton
    local UseContainerItem = UseContainerItem
    local PickupContainerItem = PickupContainerItem
    local PickupGuildBankItem = PickupGuildBankItem
    local GetItemQualityColor = GetItemQualityColor
    local SplitContainerItem = SplitContainerItem
    local SplitGuildBankItem = SplitGuildBankItem
    local ClickVoidStorageSlot = ClickVoidStorageSlot
    local GetCurrentGuildBankTab = GetCurrentGuildBankTab
    local AutoStoreGuildBankItem = AutoStoreGuildBankItem
    local GetCVarBool = GetCVarBool
    local IsShiftKeyDown = IsShiftKeyDown
    local IsModifiedClick = IsModifiedClick
    local IsControlKeyDown = IsControlKeyDown
    local HandleModifiedItemClick = HandleModifiedItemClick
    local SocketContainerItem = SocketContainerItem
    local GetMoneyString = GetMoneyString
    local ColorPickerFrame = ColorPickerFrame
    local FauxScrollFrame_OnVerticalScroll = FauxScrollFrame_OnVerticalScroll
    local IsBagOpen, OpenBag = IsBagOpen, OpenBag
    local IsArtifactPowerItem = IsArtifactPowerItem
    local SocketInventoryItem = SocketInventoryItem
    local SpellCanTargetItem = SpellCanTargetItem
    local SpellCanTargetItemID = SpellCanTargetItemID
    local DressUpItemLink = DressUpItemLink
    local SplitStack = SplitStack
    local ContainerFrameItemButton_OnClick = ContainerFrameItemButton_OnClick
    local StackSplitFrame = StackSplitFrame

    local B, L, T = unpack(select(2, ...))
    B.Auctions = {['Buttons'] = {}}


--[[//////////////////////////////////////////////////

    CREATE FRAME AND BUTTONS

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]


    function B.Auctions:CreateFrame()

        T.F.mainframe.character.auctions = CreateFrame("Frame", "BWcharacterauctions", T.F.mainframe.character, "BackdropTemplate")
        T.F.mainframe.character.auctions:SetWidth(310)
        T.F.mainframe.character.auctions:SetHeight(250)
        T.F.mainframe.character.auctions:SetFrameStrata("HIGH")
        T.F.mainframe.character.auctions.total = 0
        T.F.mainframe.character.auctions.totalitems = 0
        T.F.mainframe.character.auctions:Hide()
        T.F.mainframe.character.auctions:EnableMouse(true)
        T.F.mainframe.character.auctions:SetScript("OnShow", self.Show)
        T.F.mainframe.character.auctions:SetScript("OnHide", self.Hide)

        T.F.mainframe.character.auctions.enddot = T.F.mainframe.character.auctions:CreateTexture(nil, "OVERLAY")
        T.F.mainframe.character.auctions.enddot:SetMask("Textures\\MinimapMask")
        T.F.mainframe.character.auctions.enddot:SetHeight(5)
        T.F.mainframe.character.auctions.enddot:SetWidth(5)
        T.F.mainframe.character.auctions.enddot:SetTexture("Interface\\Buttons\\WHITE8x8")
        T.F.mainframe.character.auctions.enddot:SetVertexColor(1, 1, 1, 1)
        T.F.mainframe.character.auctions.enddot:SetPoint("TOP", T.F.mainframe.character.auctions, "BOTTOM", 0, 12)

        B.I.CreateScroll(T.F.mainframe.character.auctions, "FauxScrollFrameBWauctions", B.Auctions.Update, "BWauctionsScrollFrame", B.Auctions.Buttons.Create, 28)
    end

    function B.Auctions:Show()
        T.F.mainframe.character.auctionstab:SetBackdropBorderColor(1, 1, 1, 1)
    end

    function B.Auctions:Hide()
        T.F.mainframe.character.auctionstab:SetBackdropBorderColor(0, 0, 0, 1)
    end


    function B.Auctions:CreateTab()

        T.F.mainframe.character.auctionstab = B.I.Tab.Create(T.F.mainframe.character, nil, "BackdropTemplate")
        T.F.mainframe.character.auctionstab:SetPoint("TOPLEFT", T.F.mainframe.character.equipmenttab, "BOTTOMLEFT", 0, -4)
        T.F.mainframe.character.auctionstab:SetNormalTexture("Interface\\Icons\\INV_Misc_Coin_04")
        T.F.mainframe.character.auctionstab:HookScript("OnClick", self.Click)
        T.F.mainframe.character.auctionstab:HookScript("OnEnter", self.Enter)
        T.F.mainframe.character.auctionstab:SetScript("OnLeave", self.Leave)
    end

    function B.Auctions:Click(...)

        T.F.mainframe.character.equipment:Hide()
        T.F.mainframe.character.mail:Hide()
        --T.F.mainframe.farm:Hide()

        if T.F.mainframe.character.auctions:IsVisible() then
            T.F.mainframe.character.auctions:Hide()
        else
            B.Auctions:Update()
            T.F.mainframe.character.auctions:Show()
        end
    end

    function B.Auctions:Enter()

        if T.F.mainframe.layout > 2 then
            GameTooltip:SetOwner(self, "ANCHOR_LEFT", 10, -10)
        else
            GameTooltip:SetOwner(self, "ANCHOR_RIGHT", -10, -10)
        end

        local text = L[9001]
        if T.F.mainframe.character.auctions.totalitems > 0 then
            text = text.." ("..T.F.mainframe.character.auctions.totalitems..")"
        end
        GameTooltip:SetText(text)

        if T.F.mainframe.character.auctions.total > 0 then
            GameTooltip:AddLine(GetMoneyString(T.F.mainframe.character.auctions.total, true))
        end
        GameTooltip:Show()
    end

    function B.Auctions:Leave()
        GameTooltip:Hide()
    end


    function B.Auctions.Buttons:Create()

        local button = B.I.TabList.Button(index, T.F.mainframe.character.auctions.list)

        button:SetScript("OnEnter", B.Auctions.Buttons.Enter)
        button:SetScript("OnLeave", B.Auctions.Buttons.Leave)
        button:SetScript("OnClick", B.Auctions.Buttons.Click)

        button.leftstring:SetPoint("LEFT", button.icon, "RIGHT", 10, 0)
        button.leftstring:SetPoint("RIGHT", button, "RIGHT", -button.rightstring.bg:GetWidth(), 0)

        return button
    end

    function B.Auctions.Buttons:Enter()

        local r, g, b = GetItemQualityColor(self.quality)
        self:SetBackdropBorderColor(r, g, b, 1)
        self.rightstring:SetText("( "..GetMoneyString(self.price, true).." )")

        B.I.Button.Enter(self, false)
    end

    function B.Auctions.Buttons:Leave()

        self:SetBackdropBorderColor(T.THEME.r, T.THEME.g, T.THEME.b, 1)
        self.rightstring:SetText(GetMoneyString(self.price * (self.count or 1), true))
        GameTooltip:Hide()
    end

    function B.Auctions.Buttons:Click()
        T.F.mainframe.searchbar:SetText(self.name)
    end


--[[//////////////////////////////////////////////////

    FUNCTIONS

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]


    function B.Auctions:Scan()
        local auction, x, count, status, index, price, bidAmount
        local auctions = T['auctions']
        local totalAuctions = C_AuctionHouse.GetNumOwnedAuctions()

        table.wipe(auctions[1])

        for x = 1, totalAuctions do
            auction = C_AuctionHouse.GetOwnedAuctionInfo(x)
            count = auction['quantity']
            bidAmount = auction['bidAmount']
            price = auction['buyoutAmount']
            --_, _, count, _, _, _, _, bid, _, price, bidAmount, _, _, _, _, status = C_AuctionHouse.GetOwnedAuctionInfo(x)
            if auction['status'] == 0 then
                index = #auctions[1] + 1
                auctions[1][index] = B.Scan(auctions[1][index], auction['itemLink'], count)
                auctions[1][index]['time'] = GetTime() + auction['timeLeftSeconds']
                --auctions[1][index]['time'] = GetTime() + T.TIMEINDEX[C_AuctionHouse.GetOwnedAuctionItemTimeLeft(x)] -- when auction will actually expire
                auctions[1][index]['price'] = price > 0 and price or bidAmount > 0 and bidAmount --or bid > 0 and bid
            end
        end
    end

    function B.Auctions:Update()

        local time = GetTime()
        local r, g, b, k, v, idx, link, hexcolor, ilvl
        local name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice
        local auctions = B.GetPlayerBank('auctions')[1]
        local total_items = #auctions
        local currentscrollbarvalue = FauxScrollFrame_GetOffset(T.F.mainframe.character.auctions.scroll)
        local rows = B.RowsToFit(T.F.mainframe.character.auctions, 28)

        FauxScrollFrame_Update(T.F.mainframe.character.auctions.scroll, total_items, rows, 28)
        for x = 1, rows do
            -- Clear buttons
            B.ResetButton(T.F.mainframe.character.auctions.list.buttons[x])
            --T.F.mainframe.character.auctions.list.buttons[x]:SetBackdropColor(T.THEME.r, T.THEME.g, T.THEME.b, T.THEME.a)
            T.F.mainframe.character.auctions.list.buttons[x]:SetBackdropBorderColor(T.THEME.r, T.THEME.g, T.THEME.b, 1)
            T.F.mainframe.character.auctions.list.buttons[x].leftstring:SetText("")
            T.F.mainframe.character.auctions.list.buttons[x].rightstring.time:SetVertexColor(0.02, 0.76, 0.31, 1)
            --T.F.mainframe.character.auctions.list.buttons[x].rightstring.bg:SetVertexColor(T.THEME.r, T.THEME.g, T.THEME.b, 1)
            T.F.mainframe.character.auctions.list.buttons[x]:Hide()
            T.F.mainframe.character.auctions.enddot:Hide()
        end

        local total = 0
        for x = 1, #auctions do
            total = total + (auctions[x].price * (auctions[x].count or 1))
        end

        for x = 1, rows do
            -- Get the appropriate item, which will be x + value
            idx = x + currentscrollbarvalue

            if auctions[idx] then
                if strmatch(auctions[idx].link, "|Hbattlepet:") then
                    name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture, vendorPrice = B.GetPetInfo(auctions[idx].link)
                else
                    name, link, quality, iLevel, reqLevel, class, subclass, maxStack, equipSlot, texture = GetItemInfo(auctions[idx].link)
                end
                if name then
                    r, g, b, hexcolor = GetItemQualityColor(quality)

                    T.F.mainframe.character.auctions.list.buttons[x].quality = quality
                    T.F.mainframe.character.auctions.list.buttons[x].name = name
                    T.F.mainframe.character.auctions.list.buttons[x].price = auctions[idx].price 
                    T.F.mainframe.character.auctions.list.buttons[x].count = auctions[idx].count
                    T.F.mainframe.character.auctions.list.buttons[x].icon:SetTexture(texture)
                    T.F.mainframe.character.auctions.list.buttons[x].leftstring:SetText("|c"..hexcolor..name.."|r")
                    T.F.mainframe.character.auctions.list.buttons[x].rightstring:SetText(GetMoneyString(auctions[idx].price * (auctions[idx].count or 1), true))
                    if auctions[idx].count and auctions[idx].count > 1 then
                        T.F.mainframe.character.auctions.list.buttons[x].text:SetText(auctions[idx].count)
                    end

                    if (class == L[9004] or class == L[9005]) and (quality and quality > 1) then -- ILVL for green quality or higher
                        ilvl = B.DetectILVL(link)
                        if ilvl then
                            T.F.mainframe.character.auctions.list.buttons[x].ilvl:SetText(ilvl > 1 and ilvl or nil)
                            T.F.mainframe.character.auctions.list.buttons[x].ilvl:SetTextColor(r, g, b, 1)
                        else
                            T.F.mainframe.character.auctions.list.buttons[x].ilvl:SetText(iLevel > 1 and iLevel or nil)
                            T.F.mainframe.character.auctions.list.buttons[x].ilvl:SetTextColor(r, g, b, 1)
                        end
                    end

                    for _, v in ipairs(T.TIMEINDEX) do
                        k = T.TIME[v]
                        if (auctions[idx].time - time) <= v then
                            T.F.mainframe.character.auctions.list.buttons[x].rightstring.time:SetVertexColor(k.r, k.g, k.b, k.a)
                            break
                        end
                    end

                    T.F.mainframe.character.auctions.list.buttons[x].link = auctions[idx].link
                    T.F.mainframe.character.auctions.list.buttons[x]:Show()
                    T.F.mainframe.character.auctions.enddot:Show()
                    if idx == total_items then
                        T.F.mainframe.character.auctions.enddot:Hide()
                    end
                end
            end
        end
        T.F.mainframe.character.auctionstab:SetNormalTexture(GetCoinIcon(total / 100))
        T.F.mainframe.character.auctions.total = total
        T.F.mainframe.character.auctions.totalitems = total_items
    end

    function B.Auctions:Search(text)
        local item, link, info, temp, result
        local auctions = B.GetPlayerBank('auctions')[1]

        if not text then return end

        if next(auctions) then
            for x = 1, #auctions do

                link = auctions[x]['link']
                info = strmatch(link, "|Hbattlepet:") and {B.GetPetInfo(link)} or {GetItemInfo(link)}

                temp = B.newtable()
                temp.name = info[1]
                temp.quality = info[3]
                temp.link = link
                temp.class = info[6]
                temp.subclass = info[7]
                temp.equipslot = info[9]

                if B.find(text, temp) then
                    result = T.BW.items("auctions", 1, link) -- use metatable __call to group items
                    result['count'] = result['count'] + (auctions[x]['count'] or 1)
                end
            end
        end
    end

    function B.Auctions:Clean(bank)

        local x
        local auctions = T['auctions']
        local time = GetTime()

        for x = #auctions[1], 1, -1 do
            if auctions[1][x] then
                if auctions[1][x]['time'] <= time then -- expired
                    table.remove(auctions[1][x], x)
                end
            end
        end
    end

    function B.Auctions:CleanAlts()

        local k, v, p, b

        for k, v in pairs(BWsavedtable) do
            if not T.OPTIONS[k] and type(v) == "table" then
                for p, b in pairs(v) do
                    if p ~= UnitName('player').."."..string.sub(UnitFactionGroup('player'), 1, 1) then
                        self:Clean(b['auctions'])
                    end
                end
            end
        end
    end


--[[//////////////////////////////////////////////////

    POSITION

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]


    function B.Auctions:Anchor(startpoint, endpoint, from, to)

        T.F.mainframe.character.auctions:ClearAllPoints()
        T.F.mainframe.character.auctions:SetPoint("TOP"..from, T.F.mainframe.character.equipmenttab, "TOP"..to)

        T.F.mainframe.character.auctions.list:ClearAllPoints()
        T.F.mainframe.character.auctions.list:SetPoint("TOP"..from, T.F.mainframe.character.auctions)
        T.F.mainframe.character.auctions.list:SetPoint("BOTTOM"..to, T.F.mainframe.character.auctions)

        local x
        for x = 1, #T.F.mainframe.character.auctions.list.buttons do
            T.F.mainframe.character.auctions.list.buttons[x].rightstring.time:ClearAllPoints()
            T.F.mainframe.character.auctions.list.buttons[x].rightstring.time:SetPoint(to, to == "RIGHT" and 3 or -3, 0)
        end
    end
