-- GLOBALS: unpack, select, LibStub, ITEM_SEARCHBAR_LIST
-- GLOBALS: VoidStorageFrame, ReagentBankFrame, MerchantFrame

--[[//////////////////////////////////////////////////

    GLO-LO

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]

    local _G = _G
    local math = math
    local tostring = tostring
    local tonumber = tonumber
    local string = string
    local pairs = pairs
    local format = format
    local tinsert = tinsert
    local strmatch = strmatch
    local strsplit = strsplit

    local CreateFrame = CreateFrame
    local UIParent = UIParent
    local ResetCursor = ResetCursor
    local SetCursor = SetCursor
    local ShowInspectCursor = ShowInspectCursor
    local GameTooltip = GameTooltip
    local GameTooltip_Hide = GameTooltip_Hide
    local GameTooltip_ShowCompareItem = GameTooltip_ShowCompareItem
    local BattlePetToolTip_Show = BattlePetToolTip_Show
    local BattlePetTooltip = BattlePetTooltip
    local CloseDropDownMenus = CloseDropDownMenus
    local ToggleDropDownMenu = ToggleDropDownMenu
    local UIDropDownMenu_CreateInfo = UIDropDownMenu_CreateInfo
    local UIDropDownMenu_SetWidth = UIDropDownMenu_SetWidth
    local UIDropDownMenu_Initialize = UIDropDownMenu_Initialize
    local UIDropDownMenu_AddButton = UIDropDownMenu_AddButton
    local UseContainerItem = UseContainerItem
    local PickupContainerItem = PickupContainerItem
    local PickupGuildBankItem = PickupGuildBankItem
    local GetItemQualityColor = GetItemQualityColor
    local SplitContainerItem = SplitContainerItem
    local SplitGuildBankItem = SplitGuildBankItem
    local ClickVoidStorageSlot = ClickVoidStorageSlot
    local GetCurrentGuildBankTab = GetCurrentGuildBankTab
    local AutoStoreGuildBankItem = AutoStoreGuildBankItem
    local GetCVarBool = GetCVarBool
    local IsShiftKeyDown = IsShiftKeyDown
    local IsModifiedClick = IsModifiedClick
    local IsControlKeyDown = IsControlKeyDown
    local HandleModifiedItemClick = HandleModifiedItemClick
    local SocketContainerItem = SocketContainerItem
    local GetMoneyString = GetMoneyString
    local ColorPickerFrame = ColorPickerFrame
    local FauxScrollFrame_OnVerticalScroll = FauxScrollFrame_OnVerticalScroll
    local IsBagOpen, OpenBag = IsBagOpen, OpenBag
    local IsArtifactPowerItem = IsArtifactPowerItem
    local SocketInventoryItem = SocketInventoryItem
    local SpellCanTargetItem = SpellCanTargetItem
    local SpellCanTargetItemID = SpellCanTargetItemID
    local DressUpItemLink = DressUpItemLink
    local SplitStack = SplitStack
    local ContainerFrameItemButton_OnClick = ContainerFrameItemButton_OnClick
    local StackSplitFrame = StackSplitFrame

    local B, L, T = unpack(select(2, ...))
    B.Farm = {}


--[[//////////////////////////////////////////////////

    CREATE FRAME AND BUTTONS

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]


    function B.Farm:CreateFrame()

        T.F.mainframe.farm = CreateFrame("Frame", "BWcharacterfarm", T.F.mainframe, "BackdropTemplate")
        T.F.mainframe.farm:SetWidth(20 + (T.BUTTON_HEIGHT * 5) + (T.FRAMEWHITESPACE * (5 - 1)))
        T.F.mainframe.farm:SetHeight(300)
        T.F.mainframe.farm:SetClampedToScreen(true)
        T.F.mainframe.farm:SetFrameStrata("HIGH")
        T.F.mainframe.farm:Hide()

        T.F.mainframe.farm:SetScript("OnShow", function(self)
            T.F.mainframe.character.farmtab:SetBackdropBorderColor(1, 1, 1, 1)
        end)
        T.F.mainframe.farm:SetScript("OnHide", function(self)
            T.F.mainframe.character.farmtab:SetBackdropBorderColor(0, 0, 0, 1)
        end)

        B.I.Backdrop(T.F.mainframe.farm)
    end

    function B.Farm:CreateTab()

        T.F.mainframe.character.farmtab = B.I.Tab.Create(T.F.mainframe.character, nil, "BackdropTemplate")
        T.F.mainframe.character.farmtab:SetNormalTexture(134332)
        T.F.mainframe.character.farmtab:HookScript("OnClick", self.Click)
    end

    function B.Farm:Click(...)

        T.F.mainframe.character.equipment:Hide()
        T.F.mainframe.character.auctions:Hide()
        T.F.mainframe.character.mail:Hide()

        if T.F.mainframe.farm:IsVisible() then
            T.F.mainframe.farm:Hide()
        else
            T.F.mainframe.farm:Show()
        end
    end


    function B.Farm:CreateButtons()

    end

    function B.Farm:AddEnable(...)

        self:LockHighlight()
    end

    function B.Farm:AddDisable(...)

        self:UnlockHighlight()
    end

    function B.Farm:PrevClick(...)
        print("prev list!")
    end


    function B.Farm:NextClick(...)
        print("next list!")
    end


--[[//////////////////////////////////////////////////

    FUNCTIONS

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]


--[[//////////////////////////////////////////////////

    POSITION

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]


    function B.Farm:Anchor(startpoint, endpoint, from, to)

        T.F.mainframe.farm:ClearAllPoints()
        T.F.mainframe.farm:SetPoint("TOP"..from, T.F.mainframe.character.equipmenttab, "TOP"..to)
    end

