-- GLOBALS: unpack, select, LibStub, ITEM_SEARCHBAR_LIST
-- GLOBALS: VoidStorageFrame, ReagentBankFrame, MerchantFrame

--[[//////////////////////////////////////////////////

    GLO-LO

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]

    local _G = _G
    local math = math
    local tostring = tostring
    local tonumber = tonumber
    local string = string
    local pairs = pairs
    local format = format
    local tinsert = tinsert
    local strmatch = strmatch
    local strsplit = strsplit

    local CreateFrame = CreateFrame
    local UIParent = UIParent
    local ResetCursor = ResetCursor
    local SetCursor = SetCursor
    local ShowInspectCursor = ShowInspectCursor
    local GameTooltip = GameTooltip
    local GameTooltip_Hide = GameTooltip_Hide
    local GameTooltip_ShowCompareItem = GameTooltip_ShowCompareItem
    local BattlePetToolTip_Show = BattlePetToolTip_Show
    local BattlePetTooltip = BattlePetTooltip
    local CloseDropDownMenus = CloseDropDownMenus
    local ToggleDropDownMenu = ToggleDropDownMenu
    local UIDropDownMenu_CreateInfo = UIDropDownMenu_CreateInfo
    local UIDropDownMenu_SetWidth = UIDropDownMenu_SetWidth
    local UIDropDownMenu_Initialize = UIDropDownMenu_Initialize
    local UIDropDownMenu_AddButton = UIDropDownMenu_AddButton
    local UseContainerItem = UseContainerItem
    local PickupContainerItem = PickupContainerItem
    local PickupGuildBankItem = PickupGuildBankItem
    local GetItemQualityColor = GetItemQualityColor
    local SplitContainerItem = SplitContainerItem
    local SplitGuildBankItem = SplitGuildBankItem
    local ClickVoidStorageSlot = ClickVoidStorageSlot
    local GetCurrentGuildBankTab = GetCurrentGuildBankTab
    local AutoStoreGuildBankItem = AutoStoreGuildBankItem
    local GetCVarBool = GetCVarBool
    local IsShiftKeyDown = IsShiftKeyDown
    local IsModifiedClick = IsModifiedClick
    local IsControlKeyDown = IsControlKeyDown
    local HandleModifiedItemClick = HandleModifiedItemClick
    local SocketContainerItem = SocketContainerItem
    local GetMoneyString = GetMoneyString
    local ColorPickerFrame = ColorPickerFrame
    local FauxScrollFrame_OnVerticalScroll = FauxScrollFrame_OnVerticalScroll
    local IsBagOpen, OpenBag = IsBagOpen, OpenBag
    local IsArtifactPowerItem = IsArtifactPowerItem
    local SocketInventoryItem = SocketInventoryItem
    local SpellCanTargetItem = SpellCanTargetItem
    local SpellCanTargetItemID = SpellCanTargetItemID
    local DressUpItemLink = DressUpItemLink
    local SplitStack = SplitStack
    local ContainerFrameItemButton_OnClick = ContainerFrameItemButton_OnClick
    local StackSplitFrame = StackSplitFrame

    local B, L, T = unpack(select(2, ...))
    B.Toggle = {}


--[[//////////////////////////////////////////////////

    CREATE FRAME AND BUTTONS

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]


    function B.Toggle:CreateFrame()

        local frame = CreateFrame("Frame", "BWtoggleframe", UIParent, "BackdropTemplate")
        frame:SetAllPoints()
        frame:SetScript("OnShow", function(self) BWconfig['state'] = 1 end)
        frame:SetScript("OnHide", function(self)  BWconfig['state'] = 0 end)

        T.F.toggleframe = frame
    end

    function B.Toggle:CreateButton()

        local button = B.I.Main.Frame.Button(nil, T.F.toggleframe)
        button:SetHighlightTexture("")
        button:SetAllPoints(T.F.mainframe.optionbutton)
        button:SetClampedToScreen(true)
        button:SetBackdropColor(0.07, 0.07, 0.07, 0.8)
        button:SetBackdropBorderColor(0.15, 0.15, 0.15, 1)
        button:Hide()
        button:SetScript("OnEnter", self.Enter)
        button:SetScript("OnLeave", self.Leave)
        button:SetScript("OnShow", self.Show)
        button:SetScript("OnHide", self.Hide)
        button:SetScript("OnClick", self.Click)

        T.F.mainframe.togglebutton = button

        local status = T.F.toggleframe:CreateTexture(nil, "OVERLAY") -- just texture that tracks the status of the bar
        status:SetHeight(18)
        status:SetWidth(18)
        status:SetTexture(T.icon)
        status:SetVertexColor(1, 1, 1, 1)
        status:SetBlendMode("ADD")
        status:SetPoint("CENTER", T.F.mainframe.optionbutton, -0.5, 0.5)
        status:SetParent(T.F.mainframe.optionbutton)

        T.F.status = status
    end

    function B.Toggle:Show()
        T.F.status:SetParent(T.F.mainframe.togglebutton)
        T.F.status:SetVertexColor(0.37, 0.07, 0.02, 1)
        T.F.mainframe:Hide()
    end

    function B.Toggle:Hide()
        T.F.mainframe:Show()
    end

    function B.Toggle:Click()
        if InCombatLockdown() then return end
        self:Hide()
    end

    function B.Toggle:Enter()

        T.F.status:SetVertexColor(0.01, 0.79, 0.15, 1)
        self:SetBackdropBorderColor(0.01, 0.79, 0.15, 1)
    end

    function B.Toggle:Leave()

        T.F.status:SetVertexColor(0.37, 0.07, 0.02, 1)
        self:SetBackdropBorderColor(0.15, 0.15, 0.15, 1)
    end


--[[//////////////////////////////////////////////////

    FUNCTIONS

----\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\]]
